.586
.model flat, stdcall
option casemap :none
;************************************************************
;  08.11.2002   U.Neudecker
;  SearchAll   : Binary search in a sorted table 
;  Params      : Pointer to table 
;                Pointer to search-item
;                Pointer to table-index (Index 1-based)
;                Record length
;                Records count
;                Position of search-item  (1-based)
;                Length of search-item
; 
;  Returns EAX : -1 not found
;                0 item found  
;
;
;************************************************************

StrComp PROTO :DWORD,:DWORD,:DWORD
  
.code
;###################################################################################
SearchAll proc uses ebx ecx edx esi , 
           pArray:dword,      ; pointer to table
           pSearch:dword,     ; pointer to search-item
           pIndex:dword,      ; pointer to index  (1-based)
           LenRow:dword,      ; length of row
           Rows:dword,        ; count of rows
           SearchPos:dword,   ; search-position in row (1-based)
           SearchLen:dword    ; length of search-item
;###################################################################################

Local iMid:DWORD
Local iLow:DWORD
Local SearchOffset:DWORD

        mov esi,    SearchPos
        mov eax,    pArray
        sub esi,    1
        mov iLow,   1
        add eax,    esi
        mov ecx,    Rows                      
        mov SearchOffset, eax                                ; address of first tab-item to search
       
        .while iLow <= ecx                                   ; ecx := iUpper
            mov eax,    ecx                 
            add eax,    iLow                                 ; eax = iLow + iUpper
            shr eax,    1                   
            mov iMid,   eax                                  ; iMid = (iLow + iUpper) div 2
            sub eax,    1
            xor edx,    edx
            mul LenRow                                       ; iMid * lenRow
            add eax,    SearchOffset                         ; offset of tab-item(iMid)
            invoke StrComp, eax, pSearch, SearchLen          ; comparing tab-item <> search-item
            .if eax == 0                                     ; search-item found
               mov eax,     iMid
               mov esi,     pIndex
               mov [esi],   eax                              ; return tab-index (1-based)
               xor eax,     eax
               ret
            .else
                .if eax == dword ptr[-1]                     ; tab-item < search-item
                    mov eax, iMid
                    add eax, 1
                    mov iLow, eax                            ; iLow = iMid + 1 
                .else                                        ; tab-item > search-item
                    mov ecx, iMid
                    sub ecx, 1                               ; iUpper = iMid - 1 
                .endif
            .endif

        .endw
@@:        
        mov eax, iMid
        mov esi, pIndex
        mov [esi], eax                    ; returning last tab-index
        mov eax, dword ptr[-1]            ; not found
        ret        
SearchAll endp

align 16
;###################################################################################
; Get lowest index !
SearchAll1 proc uses edx esi edi, 
           pArray:dword,
           pSearch:dword,         
           pIndex:dword,        
           LenRow:dword,       
           Rows:dword,        
           SearchPos:dword,
           SearchLen:dword
;###################################################################################

    invoke SearchAll, pArray, pSearch, pIndex, LenRow, Rows, SearchPos, SearchLen
    .if eax == 0
@@:
        mov esi, pIndex               
        mov eax, [esi] 
        .if eax > 1
            sub eax, 1
            xor edx, edx
            mul LenRow
            add eax, SearchPos
            sub eax, 1              
            mov esi, pArray
            add esi, eax                 
            mov edi, esi
            sub edi, LenRow
            invoke StrComp, esi, edi, SearchLen
            .if eax == 0                              
               mov esi, pIndex                              
               sub dword ptr[esi], 1  
               jmp @B
            .else
               xor eax, eax
               ret
            .endif            
       .else            
            ret  
       .endif
    .endif    
    ret
SearchAll1 endp


END

